package  
{
	import entity.AiOrganism;
	import entity.Booster;
	import entity.Food;
	import entity.HumanOrganism;
	import entity.Poison;
	import util.Random;
	import util.Vec2;
	/**
	 * ...
	 * @author 
	 */
	public class LevelGen 
	{
		private var _rnd:Random;
		public static const _bodyColor:Array = [0x600000, 0xa08c00, 0x000000, 0xffffff];
		public static const _ringColor:Array = [0x700000, 0xa0d700, 0xffffff, 0x304944];
		public static const _cellColor:Array = [0xff0000, 0xa0dead, 0x707070, 0xd4d4d4];
		
		public function LevelGen() 
		{
		}
		
		public function generate(gen:int):World
		{
			_rnd = new Random(gen);
			const w:World = new World();
			
			_addFood(w, _rnd.nextIntRange(100, 200), gen);
			_addPoison(w, _rnd.nextIntRange(0, 10), gen);
			_addBooster(w, _rnd.nextIntRange(0, 10), Booster.Speed, 0xffffff, gen);
			_addBooster(w, _rnd.nextIntRange(0, 10), Booster.Metabolism, 0xdaa520, gen);
			_addHuman(w, _rnd.nextIntRange(1, 4), gen);
			
			const aiTeams:int = _rnd.nextIntRange(1, int(4 * gen / 10));
			for (var i:int = 0; i < aiTeams; ++i)
				_addAi(w, _rnd.nextIntRange(1, 4), i, gen);
			return w;
		}
		
		private function _addAi(w:World, n:uint, ci:uint, gen:int):void 
		{
			if (gen == 1) return;
			n = 1 + n * Math.min(1, gen / 10);
			
			const d:Number = Math.min(gen / 10, 1);
			for (var i:int = 0; i < n; ++i)
			{
				const ai:uint = AiOrganism.Ais[int(d * AiOrganism.Ais.length)-1];
				var o:AiOrganism = new AiOrganism(w, w.getFreePos(20), ai, _bodyColor[ci], _ringColor[ci], _cellColor[ci]);
				w.add(o);
				if (gen > 9)
					o.setRadius(_rnd.nextIntRange(10, 20));
			}
		}
		
		private function _addHuman(w:World, n:uint, gen:int):void 
		{
			n = 1 + n * Math.min(1, gen / 10);
			
			for (var i:int = 0; i < n; ++i)
			{
				var o:HumanOrganism = new HumanOrganism(w, w.getFreePos(20));
				w.add(o);
			}
		}
		
		private function _addFood(w:World, n:int, gen:int):void
		{
			for (var i:int = 0; i < n; ++i)
			{
				const fr:int = 2 + 6 * Math.random();
				const p:Vec2 = w.getFreePos(fr);
				w.add(new Food(w, p, fr));
			}
		}
		
		private function _addPoison(w:World, n:int, gen:int):void
		{
			if (gen < 5) return;
			n = 1 + n * Math.min(1, gen / 10);
			
			for (var i:int = 0; i < n; ++i)
			{
				const fr:int = 4 + 10 * Math.random();
				const p:Vec2 = w.getFreePos(fr);
				w.add(new Poison(w, p, fr));
			}
		}
		
		private function _addBooster(w:World, n:int, type:int, color:uint, gen:int):void
		{
			if (gen < 3) return;
			if (gen == 3 && type == Booster.Metabolism) return;
			
			n = 2 + n * Math.min(1, gen / 10);
			
			for (var i:int = 0; i < n; ++i)
			{
				const fr:int = 4 + 4 * Math.random();
				const p:Vec2 = w.getFreePos(fr);
				w.add(new Booster(w, p, fr, type, color));
			}
		}
	}
}