package entity 
{
	import entity.goal.FindBoosterGoal;
	import entity.goal.FindEnemyGoal;
	import entity.goal.FindFoodGoal;
	import entity.goal.RandomMoveGoal;
	import util.Vec2;
	/**
	 * ...
	 * @author 
	 */
	public class AiOrganism extends Organism
	{
		public static const RandomMove:uint = 1;
		public static const FindFood:uint = 2;
		public static const FindBooster:uint = 4;
		public static const FindEnemy:uint = 8;
		
		public static const All:uint = RandomMove | FindFood | FindBooster | FindEnemy;
		
		public static const Ai1:uint = RandomMove;
		public static const Ai2:uint = RandomMove | FindFood;
		public static const Ai3:uint = RandomMove | FindBooster;
		public static const Ai4:uint = RandomMove | FindEnemy;
		public static const Ai5:uint = RandomMove | FindFood | FindBooster;
		public static const Ai6:uint = RandomMove | FindFood | FindEnemy;
		public static const Ai7:uint = RandomMove | FindFood | FindBooster | FindEnemy;
		
		public static const Ais:Vector.<uint> = Vector.<uint>([Ai1, Ai2, Ai3, Ai4, Ai5, Ai6, Ai7]);
		
		private static var _ai:uint;
		
		public function AiOrganism(world:World, p:Vec2, ai:uint, 
			bodyColor:uint, ringColor:uint, cellColor:uint) 
		{
			super(world, p, bodyColor, ringColor, cellColor);
			
			_ai = ai;
			
			if (ai & FindEnemy)
				addGoal(new FindEnemyGoal(this));
			if (ai & FindBooster)
				addGoal(new FindBoosterGoal(this));
			if (ai & FindFood)
				addGoal(new FindFoodGoal(this));
			
			addGoal(new RandomMoveGoal(this));
		}
		
		public override function createChild():Organism
		{
			return new AiOrganism(getWorld(), getPos(), _ai, _bodyColor, _ringColor, _cellColor);
		}
		
		public override function tick(tick:int):void
		{
			if (Math.random() > 0.99)
				moveToCost(getDest());
			super.tick(tick);
		}
	}
}