package entity 
{
	import entity.goal.RandomMoveGoal;
	import flash.display.LineScaleMode;
	import flash.filters.GlowFilter;
	import util.Vec2;
	/**
	 * ...
	 * @author 
	 */
	public class Booster extends Entity
	{
		private var _type:int;
		private var _lastTime:Number = 0;
		public static const Speed:int = 0;
		public static const Metabolism:int = 1;
		
		public function Booster(world:World, p:Vec2, r:Number, type:int, color:uint) 
		{
			super(world, p, r);
			_type = type;

			graphics.beginFill(color, 1);
			graphics.drawCircle(0, 0, r);
			graphics.endFill();
			
			//graphics.lineStyle(1, 0xffd700, 1, false, LineScaleMode.NONE);
			//graphics.drawCircle(0, 0, r);
			
			addGoal(new RandomMoveGoal(this));
			setMaxSpeed(0.1);
		}
		
		public function applyTo(organism:Organism):void 
		{
			if (_type == Speed)
				organism.setMaxSpeed(organism.getMaxSpeed() + getRadius() * 0.01);
			else if (_type == Metabolism)
				organism.addMetabolism(getRadius() * 0.01);
		}
		
		override public function render(tick:int, a:Number):void 
		{
			const now:Number = tick + a;
			alpha = 0.65 + 0.15 * Math.sin(now / 15);
			super.render(tick, a);
		}
	}
}