package entity 
{
	import entity.goal.RandomMoveGoal;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import ui.DirectionMarker;
	import util.Vec2;
	/**
	 * ...
	 * @author 
	 */
	public class HumanOrganism extends Organism
	{
		private var _cp:Vec2 = null;
		private var _dm:DirectionMarker;
		
		public function HumanOrganism(world:World, p:Vec2) 
		{
			super(world, p, 0x0000ff, 0x1e90ff, 0x00a0a0);
			addEventListener(Event.ADDED_TO_STAGE, _onAddedToStage);
			addGoal(new RandomMoveGoal(this));
			
			_dm =  new DirectionMarker(this);
			addChild(_dm);
		}
		
		public override function render(tick:int, a:Number):void
		{
			_dm.visible = getWorld().isSelected(this);
			_dm.render(tick, alpha);
			super.render(tick, a);
		}
		
		public override function createChild():Organism
		{
			return new HumanOrganism(getWorld(), getPos());
		}
		
		private function _onAddedToStage(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, _onAddedToStage);
			addEventListener(MouseEvent.MOUSE_DOWN, _onMouseDown);
			doubleClickEnabled = true;
			addEventListener(MouseEvent.DOUBLE_CLICK, _onDoubleClick);
		}
		
		private function _onDoubleClick(e:MouseEvent):void 
		{
			_splitIt();
			mulRadius(0.7);
		}
		
		private function _onMouseUp(e:MouseEvent):void 
		{
			if (_cp == null)
				return;
			const p:Vec2 = new Vec2(e.stageX, e.stageY);
			const dir:Vec2 = p.sub(_cp);
			moveTo(getPos().add(dir));
			_cp = null;
		}
		
		private function _onMouseDown(e:MouseEvent):void { getWorld().setSelected(this); }
	}
}