package entity.goal 
{
	import entity.Entity;
	import entity.Organism;
	/**
	 * ...
	 * @author 
	 */
	public class FindEnemyGoal extends Goal
	{
		private var _e:Organism;
		private var _enemy:Organism;

		public function FindEnemyGoal(entity:Organism)
		{
			_e = entity;
		}

		public override function canRun(tick:int):Boolean
		{
			if (_enemy != null && !_enemy.canRemove())
				return true;
			_enemy = _getEnemy(150);
			return _enemy != null;
		}
		
		public override function tick(tick:int):void
		{
			if (_enemy.canRemove()) {
				_enemy = null;
				return;
			}
			
			_e.moveTo(_enemy.getPos());
		}
		
		private function _getEnemy(r:Number):Organism
		{
			var best:Organism = null
			var bestSqr:Number = Number.MAX_VALUE;
			const rsqr:Number = r * r;
			for each (var entity:entity.Entity in _e.getWorld().all())
			{
				if (!(entity is Organism))
					continue;
				
				const o:entity.Organism = entity as Organism;
				if (o.isSameTeam(_e))
					continue;
					
				if (o.getRadius() > 0.95 * _e.getRadius())
					continue;
				
				const d:Number = o.getPos().distanceSqr(_e.getPos());
				if (d > rsqr)
					continue;
				if (best == null || d < bestSqr)
				{
					best = o;
					bestSqr = d;
				}
			}
			return best;
		}
	}
}